//******************************************************************************
// countImage.java:	class pre vypocet obrazku v samostatnom threade
//
//******************************************************************************

import ORG.netlib.math.complex.*;

public class countImage implements Runnable{
	
	Thread t;
	frsc fs;
	fric fi;
	String str;
	int nOfColors;
	int ifn[] = new int[7];
	double step;
	int k,b;
	suradnice s = new suradnice();

	countImage(frsc fs, fric fi){
		
		this.fs=fs;
		this.fi=fi;
		this.s = fs.s;
		this.nOfColors = fs.nOfColors;	
		for(int i=0;i<7;i++) ifn[i] = fs.indexFn[i];
		this.step = fi.stepValue(this.s); 	
		this.t = new Thread(this);
		fs.counting = true;
	}
	
	public void run() {
	    while(true) {
     	   	 try {
        		countImageNow();
		     } 
		 catch(InterruptedException e) {
        	 	System.err.println("Interrupted");
      		 }
	    } 
  	}
	

	private void countImageNow() throws InterruptedException
	{
		for (int y=0; y<fi.imageHeight; y++)
		{
			for (int x=0; x<fi.imageWidth; x++)
			{
			    Complex z = new Complex(s.r0+x*step,s.i0+y*step);
			    for(k=0; k<s.N; k++)
			    {							// iterovanie 									funkcie pre konkretny bod
			 	   z=fs.fn(z, s.u, ifn);
			 	   if(z.abs()>s.T) break;
			    }
		            if (Math.abs(z.re())<s.T || Math.abs(z.im())<s.T)	// test 										konvergencie
			 	   b = 0;
			    else
			 	   b = (k % nOfColors) + 1;
			    fi.point(x,y,b);
			    if(fs.was_stop_quit==true || fs.was_back==true){ 
				fs.counting = false;
				fs.setEnabledAll(true);
				fs.ts.setText(fs.statusReady);	
				t.destroy();
			    }
			}
			str = Integer.toString((y+1)*100/fi.imageHeight) + '%';
			fs.ts.setText(str);
		}
		fi.redraw();
		fs.counting = false;
		fs.ts.setText(fs.statusReady);
		fs.setEnabledAll(true);
		t.destroy();
	}
	
}


