//******************************************************************************
// surFront.java:	class pre pracu so zasobnikom starych hodnot parametrov
//
//******************************************************************************


public class surFront
{

	final int Size=16;		// pocet poloziek zasobnika (max.)

	suradnice[] front = new suradnice[Size];
 
 
 // konstruktor 1
 //--------------------------------------------------------------------------
 public surFront()
 {
	 for(int i=0; i<Size; i++)
	 {
		 front[i] = new suradnice();
	 }
 }
 

 // inicializacia zasobnika
 //--------------------------------------------------------------------------
 public void init(suradnice s)
 {
	 for(int i=0; i<Size; i++)
	 {
		front[i] = new suradnice(s);
	 }
 }
 

 // vlozenie plozky do zasobnika
 //--------------------------------------------------------------------------
 public void in(suradnice s)
 {
	 if(s.equals(front[0])) return;
	 for(int i=Size-1; i>0; i--)
	 {
		 front[i] = front[i-1];
	 }
	 front[0] = new suradnice(s);
 }
 

 // vyber polozky zo zasobnika
 //--------------------------------------------------------------------------
 public suradnice out()
 {
	 suradnice s = new suradnice(front[0]);
	 for(int i=1; i<Size; i++)
	 {
		 front[i-1] = front[i];
	 }
	 return s;
 }
 
}
